define(["eglx/rbd/StrLib", "it/errepidistribuzione/egl/logisticaavanzata/common/Status"],function(){
	egl.defineRUILibrary('it.errepidistribuzione.egl.logisticaavanzata.common', 'ConditionHandlingLib',
	{
		'eze$$fileName': 'it/errepidistribuzione/egl/logisticaavanzata/common/ConditionHandlingLib.egl',
		'eze$$runtimePropertiesFile': 'it.errepidistribuzione.egl.logisticaavanzata.common.ConditionHandlingLib',
			"constructor": function() {
				if(egl.it.errepidistribuzione.egl.logisticaavanzata.common.ConditionHandlingLib['$inst']) return egl.it.errepidistribuzione.egl.logisticaavanzata.common.ConditionHandlingLib['$inst'];
				egl.it.errepidistribuzione.egl.logisticaavanzata.common.ConditionHandlingLib['$inst']=this;
				new egl.eglx.rbd.StrLib();
				this.InvalidDBRecord = 0;
				this.InvalidDBRecord = 1;
				this.DBRecordNotFound = 0;
				this.DBRecordNotFound = 2;
				this.RuntimeError = 0;
				this.RuntimeError = 3;
				this.DataAccessException = 0;
				this.DataAccessException = 4;
				this.DuplicateKey = 0;
				this.DuplicateKey = 5;
				this.AttemptChangePK = 0;
				this.AttemptChangePK = 6;
				this.ReferentialIntegrityViolation = 0;
				this.ReferentialIntegrityViolation = 7;
				this.TableNotFound = 0;
				this.TableNotFound = 8;
				this.ColumnNotFound = 0;
				this.ColumnNotFound = 9;
				this.InvaldSQLKeyWord = 0;
				this.InvaldSQLKeyWord = 10;
				this.InvalidSELECTInto = 0;
				this.InvalidSELECTInto = 11;
				this.eze$$setInitial();
			}
			,
			"eze$$setEmpty": function() {
				this.InvalidDBRecordMessage = "";
				this.DBRecordNotFoundMessage = "";
				this.loaded = false;
			}
			,
			"eze$$setInitial": function() {
				this.eze$$setEmpty();
				this.loaded = this.LoadMessages();
			}
			,
			"eze$$getAnnotations": function() {
				if(this.annotations === undefined){
					this.annotations = {};
					this.annotations["XMLRootElement"] = new egl.eglx.xml.binding.annotation.XMLRootElement("ConditionHandlingLib", null, false);
				}
				return this.annotations;
			}
			,
			"eze$$getFieldInfos": function() {
				if(this.fieldInfos === undefined){
					var annotations;
					this.fieldInfos = new Array();
				}
				return this.fieldInfos;
			}
			,
			"LoadMessages": function() {
				this.InvalidDBRecordMessage = "Invalid Record cannot be added to database";
				this.DBRecordNotFoundMessage = "Database record in table {1} was not found";
				return true;
			}
			,
			"HandleSuccess": function(status) {
				status.succeeded = true;
				status.code = 0;
				status.message = "SQL call succeeded";
			}
			,
			"HandleException": function(status, exception) {
				status.succeeded = false;
				status.code = this.DataAccessException;
				status.message = egl.checkNull(exception).message;
			}
			,
			"HandleInvalidDBRecord": function(status) {
				status.succeeded = false;
				status.code = this.InvalidDBRecord;
				status.message = this.InvalidDBRecordMessage;
			}
			,
			"HandleDBRecordNotFound": function(status, tableName) {
				var inserts =  [];
				inserts.appendElement(egl.checkNull(tableName));
				status.succeeded = false;
				status.code = this.DBRecordNotFound;
				status.message = this.bindMessage(this.DBRecordNotFoundMessage, inserts);
			}
			,
			"bindMessage": function(message, inserts) {
				var value;
				value = message;
				var insertLength;
				insertLength = inserts.getSize();
				var messageLength = 0;
				var i = 0;
				var index = 0;
				var remainder = 0;
				for (i = 1; ((i <= insertLength)); i = ((i + 1))) {
					messageLength = egl.eglx.rbd.StrLib['$inst'].characterLen(value);
					var temp = "";
					var substring;
					substring = (((("{") + egl.eglx.lang.convert(egl.eglx.lang.EString.fromEInt32, [i]))) + "}");
					index = egl.eglx.rbd.StrLib['$inst'].indexOf_2_S_S(value, substring);
					if (((index > 0))) {
						if (((index > 1))) {
							temp = egl.eglx.lang.EString.substring(message, 1, ((index - 1)));
						}
						temp = ((temp) + egl.checkNull(inserts)[inserts.checkIndex(egl.eglx.lang.EInt32.ezeCast({eze$$value : i, eze$$signature : "I;"}, false) - 1)]);
						remainder = ((index + egl.eglx.rbd.StrLib['$inst'].characterLen(substring)));
						if (((remainder < messageLength))) {
							temp = ((temp) + egl.eglx.lang.EString.substring(value, remainder, messageLength));
						}
						value = temp;
					}
				}
				return value;
			}
			,
			"setData": function(key, value) {
			}
			,
			"getInvalidDBRecord": function() {
				return InvalidDBRecord;
			}
			,
			"getDBRecordNotFound": function() {
				return DBRecordNotFound;
			}
			,
			"getRuntimeError": function() {
				return RuntimeError;
			}
			,
			"getDataAccessException": function() {
				return DataAccessException;
			}
			,
			"getDuplicateKey": function() {
				return DuplicateKey;
			}
			,
			"getAttemptChangePK": function() {
				return AttemptChangePK;
			}
			,
			"getReferentialIntegrityViolation": function() {
				return ReferentialIntegrityViolation;
			}
			,
			"getTableNotFound": function() {
				return TableNotFound;
			}
			,
			"getColumnNotFound": function() {
				return ColumnNotFound;
			}
			,
			"getInvaldSQLKeyWord": function() {
				return InvaldSQLKeyWord;
			}
			,
			"getInvalidSELECTInto": function() {
				return InvalidSELECTInto;
			}
			,
			"getInvalidDBRecordMessage": function() {
				return InvalidDBRecordMessage;
			}
			,
			"setInvalidDBRecordMessage": function(ezeValue) {
				this.InvalidDBRecordMessage = ezeValue;
			}
			,
			"getDBRecordNotFoundMessage": function() {
				return DBRecordNotFoundMessage;
			}
			,
			"setDBRecordNotFoundMessage": function(ezeValue) {
				this.DBRecordNotFoundMessage = ezeValue;
			}
			,
			"getLoaded": function() {
				return loaded;
			}
			,
			"setLoaded": function(ezeValue) {
				this.loaded = ezeValue;
			}
			,
			"toString": function() {
				return "[ConditionHandlingLib]";
			}
		}
	);
});
